#ifndef INCLUDE_H
#define INCLUDE_H

#define WIN32_EXTRA_LEAN
#define _CRT_SECURE_NO_DEPRECATE
#define NOMINMAX
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include <GL/wglext.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <NxPhysics.h>	// C++ required for ageia sdk, trying to stay C'ish if possible
#include <NxCooking.h>

#include "gltools.h"	// superbible helper library


#define WMU_IDLE	WM_APP + 1

typedef struct
{
	float	pos[3], up[3], forward[3];
} Frame;

extern PFNWGLCHOOSEPIXELFORMATARBPROC		wglChoosePixelFormatARB;
extern PFNWGLGETEXTENSIONSSTRINGARBPROC		wglGetExtensionsStringARB;
extern PFNWGLCHOOSEPIXELFORMATARBPROC		wglChoosePixelFormat;
extern PFNWGLGETPIXELFORMATATTRIBFVARBPROC	wglGetPixelFormatAttribfvARB;
extern PFNWGLGETPIXELFORMATATTRIBIVARBPROC	wglGetPixelFormatAttribivARB;
extern PFNGLACTIVETEXTUREARBPROC		glActiveTexture;
extern PFNGLGENPROGRAMSARBPROC			glGenProgramsARB;
extern PFNGLBINDPROGRAMARBPROC			glBindProgramARB;
extern PFNGLPROGRAMSTRINGARBPROC		glProgramStringARB;

//glsl
extern PFNGLSHADERSOURCEPROC			glShaderSource;
extern PFNGLCOMPILESHADERPROC			glCompileShader;
extern PFNGLCREATESHADERPROC			glCreateShader;
extern PFNGLCREATEPROGRAMPROC			glCreateProgram;
extern PFNGLATTACHSHADERPROC			glAttachShader;
extern PFNGLLINKPROGRAMPROC			glLinkProgram;
extern PFNGLVALIDATEPROGRAMPROC			glValidateProgram;
extern PFNGLUSEPROGRAMPROC			glUseProgram;
extern PFNGLDETACHSHADERPROC			glDetachShader;
extern PFNGLDELETESHADERPROC			glDeleteShader;
extern PFNGLGETSHADERIVPROC			glGetShaderiv;
extern PFNGLGETPROGRAMIVPROC			glGetProgramiv;
extern PFNGLGETSHADERINFOLOGPROC		glGetShaderInfoLog;
extern PFNGLGETPROGRAMINFOLOGPROC		glGetProgramInfoLog;
extern PFNGLGETUNIFORMLOCATIONPROC		glGetUniformLocation;
extern PFNGLUNIFORM1IPROC			glUniform1i;
extern PFNGLUNIFORM1FPROC			glUniform1f;
extern PFNGLUNIFORM2FPROC			glUniform2f;
extern PFNGLUNIFORM3FPROC			glUniform3f;
extern PFNGLUNIFORM4FPROC			glUniform4f;

//global declarations are bad
extern NxPhysicsSDK	*gPhysicsSDK;
extern NxSceneDesc	sceneDesc;
extern NxScene		*gScene;
extern GLuint		dispListSphere;
extern GLuint		dispListCube;
extern GLuint		texObject[6];
#endif